]> de.git.xonotic.org Git - xonotic/xonotic-data.pk3dir.git/blobdiff - .gitlab-ci.yml
Update gameplay hash
[xonotic/xonotic-data.pk3dir.git] / .gitlab-ci.yml
index 4cce7de00c024b8387df27d3a958c5003ef31688..87bb7bb07c412caf7368bec7950418fa7f2eb4b2 100644 (file)
@@ -1,97 +1,99 @@
-workflow:
-  rules:
-    - if: $CI_COMMIT_MESSAGE =~ /Transifex autosync/
-      when: never
-    - when: always
-
-before_script:
-  - ln -s $PWD data/xonotic-data.pk3dir
-
-  - git clone --depth=1 --branch=main https://gitlab.com/xonotic/gmqcc.git gmqcc
-  - cd gmqcc && make -j $(nproc) && export QCC="$PWD/gmqcc"
-  - cd ..
-
-report_cloc:
-  before_script:
-    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?
-  rules:
-    - changes:
-      - qcsrc/*
-  stage: test
-  script:
-    - cloc --force-lang-def=qcsrc/tools/cloc.txt --sql 1 --sql-project xonotic qcsrc | sqlite3 code.db
-    - sqlite3 code.db 'select file,nCode from t where nCode > 1000 order by nBlank+nComment+nCode desc'
-
-test_compilation_units:
-  rules:
-    - changes:
-      - qcsrc/*
-  stage: test
-  script:
-    - ./qcsrc/tools/compilationunits.sh
-
-test_sv_game:
-  stage: test
-  script:
-    - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces
-    - cd darkplaces && make sv-debug -j $(nproc) && export ENGINE="$PWD/darkplaces-dedicated -xonotic"
-    - cd ..
-
-    - mkdir -p data/maps
-    - wget -O data/stormkeep.pk3 http://beta.xonotic.org/autobuild-bsp/latest/stormkeep.pk3
-    - wget -O data/maps/stormkeep.mapinfo https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.mapinfo
-    - wget -O data/maps/stormkeep.waypoints https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints
-    - wget -O data/maps/stormkeep.waypoints.cache https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints.cache
-    - make
-    - EXPECT=92bbad07902d2d045c65e54579993365
-    - HASH=$(${ENGINE} -noconfig -nohome +exec serverbench.cfg
-      | tee /dev/stderr
-      | grep '^:'
-      | grep -v '^:gamestart:'
-      | grep -v '^:anticheat:'
-      | md5sum | awk '{ print $1 }')
-    - echo 'expected:' $EXPECT
-    - echo '  actual:' $HASH
-    - test "$HASH" == "$EXPECT"
-    - exit $?
-
-test_sv_unit:
-  stage: test
-  script:
-    - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces
-    - cd darkplaces && make sv-debug -j $(nproc) && export ENGINE="$PWD/darkplaces-dedicated -xonotic"
-    - cd ..
-
-    - mkdir maps && wget -O maps/gitlab-ci.bsp https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/_init/_init.bsp
-    - make
-    - while read line; do
-        echo $line;
-        if [[ $line == "All tests OK" ]]; then exit 0; fi;
-      done < <(${ENGINE} +developer 1 +map gitlab-ci +sv_cmd runtest +exit)
-    - exit 1
-
-# NOTE: The generated docs are incomplete - they don't contain code behind SVQC CSQC MENUQC GAMEQC ifdefs.
-# With them added to PREDEFINED, it would take over half an hour to generate the docs and even then
-# they might not be complete. Doxygen doesn't handle #elif and might not understand some QC definitions.
-doxygen:  # rename to 'pages' when gitlab.com allows pages to exceed 100MiB
-  before_script:
-    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?
-  stage: deploy
-  script:
-    - cd qcsrc && doxygen
-    - mv html ../public
-    - for i in {0..0}; do eval $(printf "echo \$id_rsa_%02d\n" $i) >> ~/.ssh/id_rsa_base64; done
-    - base64 --decode ~/.ssh/id_rsa_base64 > ~/.ssh/id_rsa
-    - chmod 600 ~/.ssh/id_rsa
-    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tLogLevel ERROR\n" >> ~/.ssh/config
-    - git config --global user.name "Gitlab CI"
-    - git config --global user.email "<>"
-    - git clone --single-branch --depth 1 ${DEPLOY_HOST}:${DEPLOY_REPO} ~/deploy_
-    - mkdir ~/deploy && mv ~/deploy_/.git ~/deploy && rm -r ~/deploy_
-    - cp -r ../public/* ~/deploy
-    - cd ~/deploy && git add -A . && git commit -m "Deploy ${CI_BUILD_REF}" && git push origin gh-pages
-  artifacts:
-    paths:
-      - public
-  only:
-    - master
+workflow:\r
+  rules:\r
+    - if: $CI_COMMIT_MESSAGE =~ /Transifex autosync/\r
+      when: never\r
+    - when: always\r
+\r
+before_script:\r
+  - ln -s $PWD data/xonotic-data.pk3dir\r
+\r
+  - export MAKEFLAGS=-j$(nproc); echo MAKEFLAGS=$MAKEFLAGS\r
+#   FIXME: -march=native -mtune=native _changes the hash_, why?!?\r
+# - export CC="gcc -pipe -march=native -mtune=native"\r
+  - export CC="gcc -pipe"\r
+\r
+  - git clone --depth=1 --branch=main https://gitlab.com/xonotic/gmqcc.git gmqcc\r
+  - make -C gmqcc || exit 1\r
+  - export QCC="$PWD/gmqcc/gmqcc"\r
+\r
+  # Makefile: don't complain about lack of tags (fetching them is slow)\r
+  - export QCCFLAGS_WATERMARK=gitlab_pipeline\r
+  # Makefile: don't compress anything or complain about lack of zip program\r
+  - export ZIP=/bin/true\r
+\r
+test_compilation_units:\r
+  rules:\r
+    - changes:\r
+      - qcsrc/**/*\r
+  stage: test\r
+  script:\r
+    - make test\r
+\r
+test_sv_game:\r
+  stage: test\r
+  script:\r
+    - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces\r
+    - make -C darkplaces sv-release || exit 1\r
+    - export ENGINE="$PWD/darkplaces/darkplaces-dedicated -xonotic -noconfig -nohome"\r
+    - make qc || exit 1\r
+\r
+    - mkdir -p data/maps\r
+    - wget -O data/maps/gitlab-ci.bsp https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/_init/_init.bsp\r
+\r
+    - while read LINE; do\r
+        echo $LINE;\r
+        [ "$LINE" = "All tests OK" ] && PASS=1;\r
+      done < <(${ENGINE} +developer 1 +map gitlab-ci +sv_cmd runtest +wait +quit)\r
+    - test "$PASS" = "1" || { echo 'sv_cmd runtest failed!'; exit 1; }\r
+\r
+    - ${ENGINE} +map gitlab-ci +sv_cmd dumpnotifs +wait +quit\r
+    - diff notifications.cfg data/data/notifications_dump.cfg ||\r
+        { echo 'Please update notifications.cfg using `dumpnotifs`!'; exit 1; }\r
+\r
+    - wget -O data/stormkeep.pk3 http://beta.xonotic.org/autobuild-bsp/latest/stormkeep.pk3\r
+    - wget -O data/maps/stormkeep.mapinfo https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.mapinfo\r
+    - wget -O data/maps/stormkeep.waypoints https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints\r
+    - wget -O data/maps/stormkeep.waypoints.cache https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints.cache\r
+\r
+    - EXPECT=458e9e611a757c745da05c85a37e576d\r
+    - HASH=$(${ENGINE} +timestamps 1 +exec serverbench.cfg\r
+      | tee /dev/stderr\r
+      | sed -e 's,^\[[^]]*\] ,,'\r
+      | grep '^:'\r
+      | grep -v '^:gamestart:'\r
+      | grep -v '^:anticheat:'\r
+      | md5sum | awk '{ print $1 }')\r
+    - echo 'expected:' $EXPECT\r
+    - echo '  actual:' $HASH\r
+    - test "$HASH" == "$EXPECT"\r
+    - exit $?\r
+\r
+\r
+# NOTE: The generated docs are incomplete - they don't contain code behind SVQC CSQC MENUQC GAMEQC ifdefs.\r
+# With them added to PREDEFINED, it would take over half an hour to generate the docs and even then\r
+# they might not be complete. Doxygen doesn't handle #elif and might not understand some QC definitions.\r
+#doxygen:  # rename to 'pages' when gitlab.com allows pages to exceed 100MiB\r
+#  before_script:\r
+#    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?\r
+#    - apt-get update\r
+#    - apt-get -y install doxygen graphviz\r
+#  stage: deploy\r
+#  script:\r
+#    - cd qcsrc && doxygen\r
+#    - mv html ../public\r
+#    - mkdir -p ~/.ssh\r
+#    - for i in {0..0}; do eval $(printf "echo \$id_rsa_%02d\n" $i) >> ~/.ssh/id_rsa_base64; done\r
+#    - base64 --decode ~/.ssh/id_rsa_base64 > ~/.ssh/id_rsa\r
+#    - chmod 600 ~/.ssh/id_rsa\r
+#    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tLogLevel ERROR\n" >> ~/.ssh/config\r
+#    - git config --global user.name "Gitlab CI"\r
+#    - git config --global user.email "<>"\r
+#    - git clone --single-branch --depth 1 ${DEPLOY_HOST}:${DEPLOY_REPO} ~/deploy_\r
+#    - mkdir ~/deploy && mv ~/deploy_/.git ~/deploy && rm -r ~/deploy_\r
+#    - cp -r ../public/* ~/deploy\r
+#    - cd ~/deploy && git add -A . && git commit -m "Deploy ${CI_BUILD_REF}" && git push origin gh-pages\r
+#  artifacts:\r
+#    paths:\r
+#      - public\r
+#  only:\r
+#    - master\r